/*
 * linesensor.h
 *
 *  Created on: Apr 21, 2009
 *      Author: Mangesh Chitnis
 */

#ifndef LINESENSOR_H_
#define LINESENSOR_H_

#include "ee.h"

/******************************************************************************/
/*                        Line Sensor Modes of Operation                      */
/******************************************************************************/
typedef enum {
	end_device_sends_line = 0,	/* End device will send 1 D image without processing*/
	end_device_background_update = 1, /* End device will remove background from the image*/
	end_device_sends_detected_lines = 2, /* End device will only send detected lines*/
	end_device_sends_only_report = 3,	/* End device will only send information about detected object*/
	end_device_sends_feature_vector = 4, /* End device will send the object related feature vector */
	end_device_does_image_classification = 5, /* End device will classify and recognize the object */
	end_device_sends_colored_lines = 6, /* End device will send the colored 1 D images */
} linesensor_mode_t;

/* ----------------------------------------------------------------------------
|  Check the line sensor mode of operation and take appropriate action         |
 ---------------------------------------------------------------------------- */
int linesensor_mode_check();

/* ----------------------------------------------------------------------------
|  Recognize the image background and store it in a background image.			|
 ---------------------------------------------------------------------------- */

int linesensor_realtime_background();


/* ----------------------------------------------------------------------------
|  Updates the one dimensional image with this background to obtain foreground image|
 ---------------------------------------------------------------------------- */
int linesensor_background_update();

/*
void linesensor_connected_labelling();

void linesensor_boundary_extraction();
*/

#endif /* LINESENSOR_H_ */
